"use strict";

const React = require("react");

const getElementPosition = require("./get-element-position");

module.exports = function useMemoizedPosition(element, extraDependencies = []) {
	return React.useMemo(() => {
		if (element != null) {
			return getElementPosition(element);
		} else {
			return {};
		}
	}, [ element, ... extraDependencies ]);
};
